"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

exports.default = getBackendBabelConfiguration;

var _common = require("./common");

var _common2 = _interopRequireDefault(_common);

var _semver = require("semver");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// "Backend" usually includes things like services, command-line tools and
// backend-specific modules.
/**
 * Copyright 2013-present, Novivia, Inc.
 * All rights reserved.
 */

// eslint-disable-next-line filenames/match-exported
function getBackendBabelConfiguration() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$eliminateNonBuil = _ref.eliminateNonBuildingCode,
      eliminateNonBuildingCode = _ref$eliminateNonBuil === undefined ? true : _ref$eliminateNonBuil,
      _ref$nodeTargetVersio = _ref.nodeTargetVersion,
      nodeTargetVersion = _ref$nodeTargetVersio === undefined ? (0, _semver.major)(process.version) : _ref$nodeTargetVersio,
      commonSettings = (0, _objectWithoutProperties3.default)(_ref, ["eliminateNonBuildingCode", "nodeTargetVersion"]);

  var backendConfiguration = (0, _common2.default)(commonSettings);

  // All ratified ECMAScript specifications, targeting a specific version of
  // Node.
  backendConfiguration.presets.unshift([require.resolve("babel-preset-env"), {
    targets: {
      node: nodeTargetVersion
    }
  }]);

  if (eliminateNonBuildingCode) {
    backendConfiguration.plugins.push([require.resolve("babel-plugin-minify-replace"), {
      replacements: [
      // "global.__BUILDING__" --> "true"
      {
        identifierName: "global",
        member: "__BUILDING__",
        replacement: {
          type: "booleanLiteral",
          value: true
        }
      }]
    }], require.resolve("babel-plugin-minify-dead-code-elimination"));
  }

  return backendConfiguration;
}
module.exports = exports["default"];