"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

exports.default = requireHook;

var _backend = require("../config/backend");

var _backend2 = _interopRequireDefault(_backend);

var _pkginfoJson = require("pkginfo-json5");

var _pkginfoJson2 = _interopRequireDefault(_pkginfoJson);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * A module providing a utility to bootstrap and configure in-memory require
 * hooks.
 */

/**
 * Copyright 2013-present, Novivia, Inc.
 * All rights reserved.
 */

function requireHook() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$babelOptions = _ref.babelOptions,
      babelOptions = _ref$babelOptions === undefined ? {} : _ref$babelOptions,
      module = _ref.module,
      rootDirectory = _ref.rootDirectory,
      _ref$useJSON = _ref.useJSON5,
      useJSON5 = _ref$useJSON === undefined ? true : _ref$useJSON,
      _ref$usePolyfill = _ref.usePolyfill,
      usePolyfill = _ref$usePolyfill === undefined ? true : _ref$usePolyfill;

  var configurationFromPackage = (0, _pkginfoJson2.default)(
  // If `module` was provided, attempt to extract additional configuration
  // options from that module's package.
  module, {
    // If `module` was not provided, use the current process' working
    // directory and still attempt to extract additional configuration options
    // from that module's package.
    dir: module ? undefined : rootDirectory || process.cwd(),
    include: ["novivia-babel"]
  })["novivia-babel"] || {};

  var babelConfiguration = (0, _backend2.default)({
    eliminateNonBuildingCode: false
  });

  var finalBabelConfiguration = (0, _extends3.default)({
    // Ignore nothing by default. "node_modules" will be added with different
    // conditions below.
    ignore: [],

    // Compile in the program directory by default.
    sourceRoot: process.cwd()

  }, babelConfiguration, configurationFromPackage.babelOptions || {}, babelOptions);

  finalBabelConfiguration.ignore = finalBabelConfiguration.ignore || [];

  /* istanbul ignore if */
  if (
  // FIXME: Replace with the proper utility once the utility module is out
  // there.
  process.env.NODE_ENV !== "production" && configurationFromPackage.includeDevScopes) {
    finalBabelConfiguration.ignore.push(new RegExp("node_modules[\\/](?!@(" + ["novivia"].concat((0, _toConsumableArray3.default)(configurationFromPackage.includeDevScopes)).join("|") + ")/)"));
  } else {
    finalBabelConfiguration.ignore.push(/node_modules/);
  }

  if (useJSON5) {
    require("json5/lib/require");
  }

  if (usePolyfill) {
    require("babel-polyfill");
  }

  require("babel-register")(finalBabelConfiguration);
}
module.exports = exports["default"];